package datacenter

import (
	"GtDataStore/app/cmd/organization/pb"
	"GtDataStore/common/xerr"
	"context"
	"github.com/jinzhu/copier"

	"GtDataStore/app/cmd/api/internal/svc"
	"GtDataStore/app/cmd/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type WorkingRoLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewWorkingRoLogic(ctx context.Context, svcCtx *svc.ServiceContext) *WorkingRoLogic {
	return &WorkingRoLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *WorkingRoLogic) WorkingRo(req *types.DcWorkingReq) (resp *types.WorkingRoResp, err error) {
	rpcResp, err := l.svcCtx.OrganizationRpc.GetWorkingUfByCode(l.ctx, &pb.DcWorkingReq{
		ProjectId:  req.ProjectId,
		DeviceCode: req.DeviceCode,
	})
	if err != nil {
		return nil, xerr.NewErrMsg("获取数据失败")
	}

	result := &types.DcWorkingRo{}
	_ = copier.Copy(result, rpcResp)

	return &types.WorkingRoResp{Info: result}, err
}
